;--------PollBot---------
menu channel,query,menubar {
  -
  PollBot
  .&PollBot Setup: dialog $iif($dialog(poll.setup),-a,-m) poll.setup poll.setup
  .&Admin Functions
  ..Add &Poll: $poll.add($$?="Enter Name of Poll")
  ..$iif($poll.read(main,totalpolls) > 0,Add Poll &Option) : $poll.addoption($$?="Poll Number",$$?="Enter Option Name")
  ..$iif($poll.read(main,totalpolls) > 0,A&nnounce a Poll) : $poll.announce($$?="Poll Number",$$?="Channel to Announce to")
  ..$iif($poll.read(main,totalpolls) > 0,&Clear Polls) : poll.clear
  ..&Restore Polls: poll.restore
  ..$iif($poll.read(main,totalpolls) > 0,C&lose a Poll) : $poll.close($$?="Poll Number")
  ..$iif($poll.read(main,totalpolls) > 0,&Open a Poll) : $poll.open($$?="Poll Number")
  ..$iif($poll.read(main,totalpolls) > 0,Remove &Poll) : $poll.remove($$?="Poll Number")
  ..$iif($poll.read(main,totalpolls) > 0,Remove Poll &Option) : $poll.remoption($$?="Poll Number",$$?="Option Number")
  ..$iif($poll.read(main,totalpolls) > 0,Add a &Vote) : $poll.addvote($$?="Poll Number",$$?="Option Number")
  ..$iif($poll.read(main,totalpolls) > 0,Remove a &Vote) : $poll.remvote($$?="Poll Number",$$?="Option Number")
  .$iif($group(#poll) == on,&Disable,&Enable) PollBot: $iif($poll.read(main,status) == on,poll.off,poll.on)
  .$iif($poll.read(main,totalpolls) > 0,&Count Total Polls) : poll.count
  .$iif($poll.read(main,totalpolls) > 0,&Show Current Polls) : poll.show
  .$iif($poll.read(main,totalpolls) > 0,Show &Individual Poll) : $poll.show($$?="Enter Poll Number to Show")
}
dialog poll.setup {
  title "PollBot Setup"
  size 10 75 200 105
  option dbu
  box "PollBot Setup", 1, 3 2 194 9
  combo 2, 3 14 50 75, drop
  text "Poll Title:", 3, 57 15 25 8
  edit "", 4, 80 14 117 10, autohs limit 120
  check "Close Poll", 10, 5 27 35 9
  button "Add Poll", 11, 91 27 30 9
  button "Delete Poll", 12, 123 27 30 9
  button "Clear Polls", 13, 155 27 30 9
  list 5, 3 39 45 70, vsbar
  button "Add", 6, 50 41 25 9
  button "Edit", 7, 50 51 25 9
  button "Remove", 8, 50 61 25 9
  edit "", 9, 79 41 118 35, read multi vsbar limit 120
  text "Votes:", 14, 79 80 16 8
  edit "", 15, 96 79 20 10, read
  text "Percent:", 16, 130 80 20 8
  edit "", 17, 151 79 24 10, read 
  button "Admins", 18, 100 94 30 9
  button "Ok", 20, 136 94 30 9 ,ok
  button "Close", 21, 168 94 30 9 ,cancel
}
on *:dialog:poll.setup:init:*: poll.setup.list
on *:dialog:poll.setup:sclick:*: {
  if ($did == 2) $poll.setup.disp($did(2).sel)
  elseif ($did == 5) $poll.setup.option($did(2).sel,$did(5).sel)
  elseif ($did == 6) { .poll.addoption $did(2).sel $$?="Enter Option Name" | $poll.setup.disp($did(2).sel,$poll.read( [ $poll.read(polls,poll [ $+ [ $did(2).sel ] ] ) ] ,totaloptions)) }
  elseif ($did == 7) {
    if ($did(7) == Edit) { %poll.votes = $did(15) | did -n $dname 9,15 | did -ra $dname 7 Save }
    else {
      did -m $dname 9,15 | did -ra $dname 7 Edit
      var %poll.curpoll $poll.read(polls,poll [ $+ [ $did(2).sel ] ] )
      var %i 1 | while ($did(9).lines >= %i) { var %poll.write = %poll.write $did(9,%i) | inc %i }
      $poll.write( [ %poll.curpoll ] ,option [ $+ [ $did(5).sel ] ] ) %poll.write
      if ($did(15) isnum) {
        $poll.write( [ %poll.curpoll ] ,vote [ $+ [ $did(5).sel ] ] ) $did(15)
        $poll.write( [ %poll.curpoll ] ,totalvotes) $calc($poll.read( [ %poll.curpoll ] ,totalvotes) + ($did(15) - %poll.votes)) 
      }
      unset %poll.votes
    }
  }
  elseif ($did == 8) { .poll.remoption $did(2).sel $did(5).sel | $poll.setup.disp($did(2).sel) }
  elseif ($did == 10) $poll.write( [ $poll.read(polls,poll [ $+ [ $did(2).sel ] ] ) ] ,status) $iif($did(10).state == 1,closed,open)
  elseif ($did == 11) { .poll.add $$?="Enter Name of Poll" | $poll.setup.list($poll.read(main,totalpolls)) }
  elseif ($did == 12) { .poll.remove $did(2).sel | poll.setup.list }
  elseif ($did == 13) { did -r $dname 2,4,5,7,9,15,17 | did -a $dname 7 Edit | did -u poll.setup 10 | did -b poll.setup 4,6,7,8,10,12,13,15 | .poll.clear }
  elseif ($did == 18) dialog $iif($dialog(poll.admin),-a,-m) poll.admin poll.admin
  elseif (($did == 20) || ($did == 21)) unset %poll.votes
}
alias -l poll.setup.list {
  did -r poll.setup 2,4,5,7,9,15,17 | did -a poll.setup 7 Edit | did -u poll.setup 10
  var %poll.polls = $poll.read(main,totalpolls)
  if (%poll.polls > 0) {
    did -e poll.setup 4,6,7,8,10,12,13,15
    var %i 1 | while (%poll.polls >= %i) { did -a poll.setup 2 Poll %i | inc %i }
    $poll.setup.disp($iif($1,$1,1))
    did -c $dname 2 $iif($1,$1,1)
  }
  else did -b poll.setup 4,6,7,8,10,12,13,15
}
alias -l poll.setup.disp {
  did -r poll.setup 4,5,9,15,17
  var %poll.curpoll = $poll.read(polls,poll [ $+ [ $1 ] ] )
  did -a poll.setup 4 $poll.read( [ %poll.curpoll ] ,name)
  did $iif($poll.read( [ %poll.curpoll ] ,status) == open,-u,-c) $dname 10
  var %poll.setup.options $poll.read( [ %poll.curpoll ] ,totaloptions)
  if (%poll.setup.options > 0) { 
    did -e poll.setup 7,8
    var %i 1 | while (%poll.setup.options >= %i) { did -a poll.setup 5 Option %i | inc %i }
    $poll.setup.option($1,$iif($2,$2,1))
    did -c poll.setup 5 $iif($2,$2,1) | did -c poll.setup 4 1
  }
  else did -b poll.setup 7,8
}
alias -l poll.setup.option {
  did -m poll.setup 9,15 | did -ra poll.setup 7 Edit
  var %poll.curpoll $poll.read(polls,poll [ $+ [ $1 ] ] )
  var %poll.votes $poll.read( [ %poll.curpoll ] ,vote [ $+ [ $2 ] ] )
  did -ra poll.setup 9 $poll.read( [ %poll.curpoll ] ,option [ $+ [ $2 ] ] )
  did -ra poll.setup 15 %poll.votes
  did -ra poll.setup 17 $iif($round($calc(100 * (%poll.votes / $poll.read( [ %poll.curpoll ] ,totalvotes))),1),$ifmatch,0) $+ %
}
dialog poll.admin {
  title "PollBot Admin Manager"
  size -1 -1 140 72
  option dbu
  box "PollBot Admin Manager", 1, 3 2 134 9
  list 2, 3 14 45 60
  button "Add", 3, 50 15 25 9
  button "Edit", 4, 50 25 25 9
  button "Remove", 5, 50 35 25 9
  text "Nickname:", 6, 85 15 25 8
  edit "", 7, 85 24 50 10,read autohs
  text "Password:", 8, 85 37 25 8
  edit "", 9, 85 46 50 10,read autohs pass
  button "Close", 20, 108 60 30 10, cancel
  button "Ok", 21, 76 60 30 10, ok
}
on *:dialog:poll.admin:init:*: { poll.admin.list }
on *:dialog:poll.admin:sclick:*: {
  if ($did == 2) { $poll.admin.disp($did(2).sel) | did -e $dname 4,5 }
  elseif ($did == 3) dialog $iif($dialog(poll.admin.add),-a,-ma) poll.admin.add poll.admin.popup
  elseif ($did == 4) { if ($dialog(poll.admin.edit)) dialog -x poll.admin.edit | dialog -ma poll.admin.edit poll.admin.popup }
  elseif ($did == 5) {
    $poll.write(main,admin) $deltok($poll.read(main,admin),$did(2).sel,46)
    poll.admin.list
  }
}
on *:dialog:poll.admin:dclick:2: { if ($dialog(poll.admin.edit)) dialog -x poll.admin.edit | dialog -m poll.admin.edit poll.admin.popup }
alias -l poll.admin.list {
  did -r poll.admin 2
  if ($poll.read(main,admin)) {
    did -e poll.admin 4,5
    var %poll.adminnum = $numtok($poll.read(main,admin),46)
    var %i 1 | while (%poll.adminnum >= %i) { did -a poll.admin 2 $gettok($gettok($poll.read(main,admin),%i,46),1,94) | inc %i }
    did -c poll.admin 2 1 | $poll.admin.disp(1)
  }
  else did -b poll.admin 4,5
}
alias -l poll.admin.disp {
  var %poll.admins.sel $gettok($poll.read(main,admin),$1,46)
  did -ra poll.admin 7 $gettok(%poll.admins.sel,1,94)
  did -ra poll.admin 9 $gettok(%poll.admins.sel,2,94)
}
dialog poll.admin.popup {
  title ""
  size -1 -1 65 56
  option dbu
  button "OK", 1, 11 45 25 9, ok
  button "Cancel", 2, 38 45 25 9, cancel
  text "Nickname:", 5, 2 2 50 9
  edit "", 4, 2 10 60 10
  text "Password:", 3, 2 23 30 9
  edit "", 6, 2 31 60 10, pass
}
on *:dialog:poll.admin.add:init:*: dialog -t $dname Add Admin
on *:dialog:poll.admin.add:edit:4: dialog -t $dname Add Admin: $did(4)
on *:dialog:poll.admin.add:sclick:1: {
  if (($did(4)) && ($did(6))) {
    $poll.write(main,admin) $addtok($poll.read(main,admin), [ [ $did(4) ] $+ ^ $+ [ $did(6) ] ] ,46)
    poll.admin.list
  }
  else halt
}
on *:dialog:poll.admin.edit:init:*: {
  dialog -t $dname Edit Admin $did(poll.admin,2).seltext
  var %poll.admin.sel $gettok($poll.read(main,admin),$did(poll.admin,2).sel,46)
  did -ra $dname 4 $gettok(%poll.admin.sel,1,94)
  did -ra $dname 6 $gettok(%poll.admin.sel,2,94)
}
on *:dialog:poll.admin.edit:sclick:1: {
  if (($did(4)) && ($did(6))) {
    $poll.write(main,admin) $instok( [ $deltok($poll.read(main,admin),$did(poll.admin,2).sel,46) ] , [ [ $did(4) ] $+ ^ $+ [ $did(6) ] ] ,$did(poll.admin,2).sel,46)
    poll.admin.list
  }
  else halt
}
#poll on
on *:text:!*p*:?: {
  if ($poll.read(floodprot,$nick)) return
  else {
    $poll.write(floodprot,$nick) 1
    .timer 1 2 $poll.rem(floodprot,$nick)
    if ($1 == !pcommands) {
      poll.reply Welcome $nick $+ , PollBot Commands:
      poll.reply !countp: Show total running polls
      poll.reply !showp: Show all current polls
      poll.reply !showp (Poll Number): Show the status of a current poll
      poll.reply !votep (Poll Number) (Option Number): Vote on a poll
      if (($wildtok($poll.read(main,admin), [ [ $nick ] $+ ^* ] ,1,46)) && ($wildtok($poll.read(main,admin), [ *^ $+ [ $2 ] ] ,1,46))) {
        poll.reply You have Admin Access and thus in addition to the normal commands, may also access the following commands:
        .timer 1 1 poll.reply !addp (Password) (Poll Name): Add a new poll
        .timer 1 2 poll.reply !addpo (Password) (Poll Number) (Option Name): Add an option to an existing poll
        .timer 1 3 poll.reply !addpv (Password) (Poll Number) (Option Number): Add a Vote to specified option on specified poll
        .timer 1 4 poll.reply !clearp (Password): Clear all polls
        .timer 1 5 poll.reply !restorep (Password): Restore cleared polls
        .timer 1 6 poll.reply !remp (Password) (Poll Number): Remove a poll
        .timer 1 7 poll.reply !rempo (Password) (Poll Number) (Option Number): Remove an option from a poll
        .timer 1 8 poll.reply !rempv (Password) (Poll Number) (Option Number): Remove a Vote from specified option on specified poll
        .timer 1 9 poll.reply !openp (Password) (Poll Number): Open a poll for voting
        .timer 1 10 poll.reply !closep (Password) (Poll Number): Close an active poll
        .timer 1 11 poll.reply !announcep (Password) (Poll Number) (Room): Announces a poll to specified room
      }
    }
    elseif ($1 == !showp) {
      if ($2 isnum) $poll.show($2)
      else poll.show
    }
    elseif ($1 == !countp) poll.count
    elseif ($1 == !votep) $poll.vote($2,$3,$nick)
    elseif (($wildtok($poll.read(main,admin), [ [ $nick ] $+ ^* ] ,1,46)) && ($wildtok($poll.read(main,admin), [ *^ $+ [ $2 ] ] ,1,46))) {
      if ($1 == !addp) $poll.add($3-)
      elseif ($1 == !addpo) $poll.addoption($3,$4-)
      elseif ($1 == !addpv) $poll.addvote($3,$4)
      elseif ($1 == !announcep) $poll.announce($3,$4)
      elseif ($1 == !clearp) poll.clear
      elseif ($1 == !restorep) poll.restore
      elseif ($1 == !openp) $poll.open($3)
      elseif ($1 == !closep) $poll.close($3)
      elseif ($1 == !remp) $poll.remove($3)
      elseif ($1 == !rempo) $poll.remoption($3,$4)
      elseif ($1 == !rempv) $poll.remvote($4,$3)
    }
  }
}
on *:text:!*p*:#: {
  if ($poll.read(floodprot,$nick)) return
  else {
    $poll.write(floodprot,$nick) 1
    .timer 1 2 $poll.rem(floodprot,$nick)
    if ($1 == !pcommands) poll.reply /msg $me !pcommands for a list of commands
    elseif ($1 == !showp) {
      if ($2 isnum) $poll.show($2)
      else poll.show
    }
    elseif ($1 == !countp) poll.count
    elseif ($1 == !votep) $poll.vote($2,$3,$nick)
  }
}
#poll end
alias -l poll.add {
  if ($1-) {
    var %poll.add $calc($poll.read(main,totalpolls) + 1)
    $poll.write(main,totalpolls) %poll.add
    $poll.write(poll [ $+ [ %poll.add ] ] ,name) $1-
    $poll.write(poll [ $+ [ %poll.add ] ] ,status) open
    $poll.write(poll [ $+ [ %poll.add ] ] ,totalvotes) 0
    $poll.write(polls,poll [ $+ [ %poll.add ] ] ) Poll $+ %poll.add
    if ($show) {
      poll.reply Poll  $+ $1- Added, there are now ( $+ %poll.add $+ ) total Polls
      poll.reply You must add options to a new poll, to add an option to your poll, type !addpo %poll.add (Option Name)
    }
  }
}
alias -l poll.addoption {
  if (($1 isnum) && ($2-)) {
    var %poll.addoption $poll.read(polls,poll [ $+ [ $1 ] ] )
    if (%poll.addoption) {
      $poll.write(%poll.addoption,totaloptions) $calc($poll.read(%poll.addoption,totaloptions) + 1)
      $poll.write(%poll.addoption,option [ $+ [ $poll.read(%poll.addoption,totaloptions) ] ] ) $2-
      $poll.write(%poll.addoption,vote [ $+ [ $poll.read(%poll.addoption,totaloptions) ] ] ) 0
      if ($show) poll.reply option $2- added to the $poll.read(%poll.addoption,Name) poll, there are now ( $+ $poll.read(%poll.addoption,totaloptions) $+ ) total options
    }
    else { poll.reply Error: You must choose a poll to add an option too }
  }
}
alias -l poll.addvote {
  if (($1 isnum) && ($2 isnum)) {
    var %poll.addvote $poll.read(polls,poll [ $+ [ $1 ] ] )
    if ((%poll.addvote) && ($poll.read(%poll.addvote,option [ $+ [ $2 ] ] ))) {
      $poll.write(%poll.addvote,totalvotes) $calc($poll.read(%poll.addvote,totalvotes) + 1)
      $poll.write(%poll.addvote,vote [ $+ [ $2 ] ] ) $calc($poll.read(%poll.addvote,vote [ $+ [ $2 ] ] ) + 1)
      poll.reply Added a vote for $poll.read(%poll.addvote,option [ $+ [ $2 ] ] ) under the $poll.read(%poll.addvote,Name) poll, there are ( $+ $poll.read(%poll.addvote,vote [ $+ [ $2 ] ] ) $+ ) total votes for this option
    }
  }
  else { poll.reply Error: Enter an option/poll number }
}
alias -l poll.announce {
  if (($1 isnum) && ($2)) {
    var %poll.announce = Attention: New poll running: $poll.read( [ $poll.read(polls,poll [ $+ [ $1 ] ] ) ] ,name)  Type !showp $1 to view the options, and !votep $1 (Option Number) to vote!
    if ($2 ischan) msg $2 %poll.announce
    else { join $2 | msg $2 %poll.announce }
  }
}
alias -l poll.clear {
  var %poll.adminlist $poll.read(main,admin)
  if ($show) poll.reply All polls have been cleared, type !addp to add a new poll
  var %i 1 | if ($exists($scriptdirpoll.bak)) {
    while ($exists($scriptdirpoll [ $+ [ ( $+ %i $+ ) ] $+ ] .bak)) { inc %i }
    .rename " $+ $scriptdirpoll.ini $+ " " $+ $scriptdirpoll $+ ( $+ %i $+ ) $+ .bak $+ "
  }
  else .rename " $+ $scriptdirpoll.ini $+ " " $+ $scriptdirpoll.bak $+ "
  $poll.write(main,admin) %poll.adminlist
}
alias -l poll.count {
  if ($poll.read(main,totalpolls)) {
    var %poll.count.votes | var %i 1
    while ($poll.read(main,totalpolls) >= %i) {
      var %poll.count $poll.read(polls,poll [ $+ [ %i ] ] )
      inc %poll.count.votes $poll.read(%poll.count,totalvotes)
      inc %i
    }
    poll.reply There are currently ( $+ %poll.count.votes $+ ) total votes in ( $+ $poll.read(main,totalpolls) $+ ) polls, type !showp to view polls
  }
}
alias -l poll.close {
  if ($1 isnum) {
    var %poll.close $poll.read(polls,poll [ $+ [ $1 ] ] )
    if (%poll.close) { $poll.write(%poll.close,status) closed | poll.reply Poll: $poll.read(%poll.close,name) is now Closed, Type !showp $1 to view the outcome, thanks for participating }
  }
}
alias poll.off { .disable #poll | amsg PollBot deactivated | $poll.write(main,status) off }
alias poll.on { .enable #poll | amsg PollBot activated, type !showp to view active polls | $poll.write(main,status) on }
alias -l poll.open {
  if ($1 isnum) {
    var %poll.open $poll.read(polls,poll [ $+ [ $1 ] ] )
    if (%poll.open) { $poll.write(%poll.open,status) open | poll.reply Poll: $poll.read(%poll.open,name) is now Open, Type !showp $1 to view the options, and !votep $1 (Option Number) to vote }
  }
}
alias -l poll.read return $readini " $+ $scriptdirpoll.ini $+ " $$1 $$2
alias -l poll.rem return .remini " $+ $scriptdirpoll.ini $+ " $$1 $$2
alias -l poll.remove {
  if ($1 isnum) {
    var %poll.remove $poll.read(polls,poll [ $+ [ $1 ] ] )
    if (%poll.remove) {
      if ($poll.read(main,totalpolls) > $remove($poll.read(polls, [ $+ [ %poll.remove ] ] ),poll)) $poll.write(polls, [ $+ [ %poll.remove ] ] ) $poll.read(polls,poll [ $+ [ $poll.read(main,totalpolls) ] ] )
      $poll.rem(polls,poll [ $+ [ $poll.read(main,totalpolls) ] ] )
      $poll.write(main,totalpolls) $calc($poll.read(main,totalpolls) - 1)
      if ($show) poll.reply Poll: $poll.read(%poll.remove,Name) removed, there are now ( $+ $poll.read(main,totalpolls) $+ ) total Polls
      .remini " $+ $scriptdirpoll.ini $+ " %poll.remove 
      if ($poll.read(main,totalpolls) == 1) $poll.rem(polls,poll [ $+ [ $calc($poll.read(main,totalpolls) + 1) ] ] )
    }
  }
  else poll.reply Error: Enter a Poll Number
}
alias -l poll.remoption {
  if (($1 isnum) && ($2 isnum)) {
    var %poll.remoption $poll.read(polls,poll [ $+ [ $1 ] ] )
    if ($show) poll.reply Option: $poll.read(%poll.remoption,option [ $+ [ $2 ] ] ) on $poll.read(%poll.remoption,Name) poll removed, there are now ( $+ $calc($poll.read(%poll.remoption,totaloptions) - 1) $+ ) total options
    $poll.write(%poll.remoption,option [ $+ [ $2 ] ] ) $poll.read(%poll.remoption,option [ $+ [ $poll.read(%poll.remoption,totaloptions) ] ] )
    $poll.rem(%poll.remoption,option [ $+ [ $poll.read(%poll.remoption,totaloptions) ] ] )
    if (($poll.read(%poll.remoption,totalvotes) > 0) && ($poll.read(%poll.remoption,vote [ $+ [ $2 ] ] ) > 0)) $poll.write(%poll.remoption,totalvotes) $calc($poll.read(%poll.remoption,totalvotes) - $poll.read(%poll.remoption,vote [ $+ [ $2 ] ] ))
    $poll.write(%poll.remoption,vote [ $+ [ $2 ] ] ) $poll.read(%poll.remoption,vote [ $+ [ $poll.read(%poll.remoption,totaloptions) ] ] )
    $poll.rem(%poll.remoption,vote [ $+ [ $poll.read(%poll.remoption,totaloptions) ] ] )
    $poll.write(%poll.remoption,totaloptions) $calc($poll.read(%poll.remoption,totaloptions) - 1)
    if ($poll.read(%poll.remoption,totaloptions) == 1) $poll.rem(%poll.remoption,option [ $+ [ $calc($poll.read(%poll.remoption,totaloptions) + 1) ] ] )
  }
  else poll.reply Error: Enter an option/poll number
}
alias -l poll.remvote {
  if (($1 isnum) && ($2 isnum)) {
    var %poll.remvote $poll.read(polls,poll [ $+ [ $1 ] ] )
    if ((%poll.remvote) && ($poll.read(%poll.remvote,option [ $+ [ $2 ] ] )) && ($poll.read(%poll.remvote,totalvotes) >= 1)) {
      $poll.write(%poll.remvote,totalvotes) $calc($poll.read(%poll.remvote,totalvotes) - 1)
      $poll.write(%poll.remvote,vote [ $+ [ $2 ] ] ) $calc($poll.read(%poll.remvote,vote [ $+ [ $2 ] ] ) - 1)
      poll.reply Removed a vote for $poll.read(%poll.remvote,option [ $+ [ $2 ] ] ) under the $poll.read(%poll.remvote,Name) poll, there are ( $+ $poll.read(%poll.remvote,vote [ $+ [ $2 ] ] ) $+ ) total votes for this option
    }
  }
  else poll.reply Error: Enter an option/poll number
}
alias -l poll.reply {
  if (# ischan) msg # $1-
  elseif ($query($nick)) msg $nick $1-
  else msg $active $1-
}
alias -l poll.restore {
  if ($exists($scriptdirpoll.bak)) {
    var %poll.adminlist $poll.read(main,admin)
    poll.reply Polls restored from poll.bak to poll.ini, type !showp to view current polls
    if ($exists($scriptdirpoll.ini)) .remove " $+ $scriptdirpoll.ini $+ "
    .rename " $+ $scriptdirpoll.bak $+ " " $+ $scriptdirpoll.ini $+ "
    $poll.write(main,admin) %poll.adminlist
  }
  else poll.reply Error: poll.bak does not exist, This function is for use to restore from a Poll Clear action
}
alias -l poll.show {
  if ($poll.read(main,totalpolls)) {
    if (($1) && ($poll.read(polls,poll [ $+ [ $1 ] ] ))) {
      var %poll.show $poll.read(polls,poll [ $+ [ $1 ] ] )
      var %poll.options $poll.read(%poll.show,totaloptions)
      var %poll.totalvotes $poll.read(%poll.show,totalvotes)
      poll.reply Options on the $poll.read(%poll.show,Name) Poll:
      var %i 1 | while (%poll.options >= %i) {
        var %poll.votes $poll.read(%poll.show,vote [ $+ [ %i ] ] )
        .timer 1 %i poll.reply %i $+ ) $poll.read(%poll.show,option [ $+ [ %i ] ] ) ( $+ %poll.votes votes $+ ) $iif($round($calc((%poll.votes / %poll.totalvotes) * 100),1),$ifmatch,0) $+ %
        inc %i
      }
      if ($poll.read(%poll.show,status) == open) poll.reply To add your vote, type !votep $1 (Option Number)
      else poll.reply This poll has been closed, thanks for your intrest
    }
    else {
      poll.reply Current Running Polls:
      var %i 1 | while ($poll.read(main,totalpolls) >= %i) {
        var %poll.show $poll.read(polls,poll [ $+ [ %i ] ] )
        poll.reply %i $+ ) $poll.read(%poll.show,name) ( $+ $poll.read(%poll.show,totalvotes) Total votes $+ ) - $poll.read(%poll.show,Status)
        inc %i
      }
      poll.reply To view the options and statistics on a poll type !showp (Poll Number)
    }
  }
}
alias -l poll.vote {
  if (($1 isnum) && ($2 isnum)) {
    var %poll.vote $poll.read(polls,poll [ $+ [ $1 ] ] )
    var %poll.address = $remove($gettok($mask($fulladdress,3),1,64),*!*)
    if (($matchtok($poll.read(%poll.vote,voted),$nick,1,46)) || ($wildtok($poll.read(%poll.vote,voted),%poll.address,1,46))) poll.reply Sorry, you have already voted for this Poll
    elseif (($poll.read(polls,poll [ $+ [ $1 ] ] )) && ($poll.read(%poll.vote,option [ $+ [ $2 ] ] ))) {
      if ($poll.read(%poll.vote,status) == open) {
        %poll.address = $nick $+ - $+ %poll.address
        $poll.write(%poll.vote,voted) $addtok($poll.read(%poll.vote,voted),%poll.address,46)
        $poll.write(%poll.vote,totalvotes) $calc($poll.read(%poll.vote,totalvotes) + 1)
        $poll.write(%poll.vote,vote [ $+ [ $2 ] ] ) $calc($poll.read(%poll.vote,vote [ $+ [ $2 ] ] ) + 1)
        poll.reply One vote added for $poll.read(%poll.vote,option [ $+ [ $2 ] ] ) by $3 under the $poll.read(%poll.vote,Name) poll, there are ( $+ $poll.read(%poll.vote,vote [ $+ [ $2 ] ] ) $+ ) total votes for this option
      }
      else poll.reply Sorry, this poll has been closed, type !showp $1 to view the results
    }
    else poll.reply Error: You entered an incorrect poll/option number, please try again
  }
  else poll.reply Error: Enter a Poll/Option Number
}
alias -l poll.write return .writeini " $+ $scriptdirpoll.ini $+ " $$1 $$2
dialog poll.badver {
  title "Version Error"
  size -1 -1 125 36
  option dbu
  text "PollBot requires mIRC version 5.81 or greater." 1, 2 3 115 9, center
  text "Get the latest version at:" 2, 4 12 59 9
  link "http://www.mirc.com" 3, 63 12 105 13
  button "Ok", 4, 50 23 20 10, ok hide
}
on *:dialog:badver.pollbot:sclick:3: run http://www.mirc.com
on *:load: { if ($version < 5.81) { $dialog(poll.badver,poll.badver) | exit } }
