;
;
;  World Time
;  by blue-elf
;  belf@mircscripter.com
;
;
;  Credits: dohcan for Dialog Studio
;           http://www.worldtimeserver.com
;

on *:load:echo -s World Time addon loaded. Type /gettime to open dialog.

menu menubar,status {
  World Time:gettime
}

alias gettime {
  if (!$dialog(worldtime)) { dialog -m worldtime worldtime }
  if (!$1) { return }
  sockclose wtime
  sockopen wtime www.worldtimeserver.com 80
  sockmark wtime CONNECTING $1-
  did -ra worldtime 4,9
  wtime.info Retrieving time for $1-
}

alias -l wtime.info {
  if ($dialog(worldtime)) { did -ra $ifmatch 4 $1- }
}
alias -l wtime.err {
  if ($isid) { return $iif($dialog(worldtime),$false,$true) }
  wtime.info Connection error: $iif($sock($1).wsmsg,$sock($1).wsmsg,Unknown)
  beep
  halt
}
alias -l wtime.nohtml { 
  var %b, %a = $regsub($1-,/(<[^>]+>)/g,$null,%b) 
  return %b
} 

on *:sockopen:wtime:{
  if ($sockerr) { wtime.err $sockname }
  elseif ($wtime.err) { sockclose wtime | halt }
  else {
    tokenize 32 $sock($sockname).mark
    var %code = $gettok($1-,-1,32)
    sockwrite -tn $sockname GET /time.asp?locationid= $+ %code
  }
}
on *:sockread:wtime:{
  if ($sockerr) { wtime.err $sockname }
  elseif ($wtime.err) { sockclose wtime | halt }
  else {
    var %a
    :a
    sockread %a
    if ($sockbr) {
      wtime.parse $sockname %a
      goto a
    }
  }
}

; I'm transferring to $1- so that the extra spaces from %a variable will be removed.
alias -l wtime.parse {
  tokenize 32 $remove($1-,$chr(9))
  var %trigger = *the current time in*
  if (%trigger iswm $2-) {
    sockmark $1 COUNTRY $gettok($sock($1).mark,2-,32)
    did -r worldtime 4,9
  }
  elseif ($gettok($sock($1).mark,1,32) == COUNTRY) {
    did -a worldtime 9 $wtime.nohtml($2-)
    sockmark $1 TIME $gettok($sock($1).mark,2-,32)
  }
  elseif ($gettok($sock($1).mark,1,32) == TIME) {
    if ((*</font><br> iswm $2-) && (<* !iswm $2-)) {
      sockmark $1 NULL
      did -a worldtime 4 $did(worldtime,4) $crlf $wtime.nohtml($2-)
    }
    else { did -a worldtime 4 $did(worldtime,4) $crlf $wtime.nohtml($2-) }
  }
}

;<p align="left"><font size="1">the current time in</font><br>
;                             <font size="2"><b>Japan</b></font><br>
;                             <center><font size="7">12:49 PM</font><br>
;       Thursday, April 25, 2002<font size="1"><br>
;       Standard Time +0900 UTC</font><br>

dialog -l worldtime {
  title "World Time"
  size -1 -1 206 195
  option dbu
  text "Location:", 1, 4 6 23 8
  list 2, 31 3 132 108, sort hsbar vsbar
  text "Time:", 3, 4 135 24 8, right
  edit "", 4, 31 133 132 41, read multi return autovs
  button "&Get time", 5, 168 18 32 12, default ok
  button "&Copy", 6, 168 126 32 12
  text "Location:", 7, 4 123 25 8, right
  box "Lookup result:", 8, 1 112 203 66
  edit "", 9, 31 121 132 11, read autohs
  text "Time brought to you by:", 10, 27 185 59 8
  link "http://www.worldtimeserver.com/", 11, 91 185 83 8
}

on *:dialog:worldtime:sclick:11:run $did(11).text
on *:dialog:worldtime:sclick:6:{
  if ($did(9)) {
    var %i = 1, %text, %temp
    while (%i <= $did(4).lines) {
      if ($did(4,%i)) {
        %temp = $ifmatch
        if (!%text) { %text = %temp }
        else { %text = %text $+ , %temp }
      }
      inc %i
    }
    var %text = The time in $did(9) is %text
    clipboard %text
    var %text = The following text has been copied to the clipboard: $+ $str($crlf,2) $+ " $+ %text $+ "
    !.echo -q $input(%text,68,Clipboard)
    if ($dialog($dname)) dialog -v $ifmatch
  }
}
on *:dialog:worldtime:sclick:5:{
  if ($did(2,$did(2).sel)) { gettime $ifmatch }
  else {
    !.echo -q $input(You must select a location from the list first.,260,World Time Error)
    if ($dialog($dname)) dialog -v $ifmatch
  }
  halt
}
on *:dialog:worldtime:init:*:{
  var %c = did -a $dname 2
  %c (UTC/GMT), UTC
  %c Afghanistan, AF
  %c Albania, AL
  %c Algeria, DZ
  %c American Samoa, AS
  %c Andorra, AD
  %c Angola, AO
  %c Anguilla, AI
  %c Antigua and Barbuda, AG
  %c Argentina, AR
  %c Armenia, AM
  %c Aruba, AW
  %c Australia, Australian Capital Territory, AU-ACT
  %c Australia, Broken Hill, AU3
  %c Australia, Lord Howe Island, AU1
  %c Australia, New South Wales, AU-NSW
  %c Australia, Northern Territory, AU-NT
  %c Australia, Queensland, AU-QLD
  %c Australia, South Australia, AU-SA
  %c Australia, Tasmania, AU-TAS
  %c Australia, Victoria, AU-VIC
  %c Australia, Western Australia, AU-WA
  %c Austria, AT
  %c Azerbaijan, AZ
  %c Bahamas, BS
  %c Bahrain, BH
  %c Bangladesh, BD
  %c Barbados, BB
  %c Belarus, BY
  %c Belgium, BE
  %c Belize, BZ
  %c Benin, BJ
  %c Bermuda, BM
  %c Bhutan, BT
  %c Bolivia, BO
  %c Bosnia and Herzegovina, BA
  %c Botswana, BW
  %c Brazil, Acre, BR-AC
  %c Brazil, Alagoas, BR-AL
  %c Brazil, Amapa, BR-AP
  %c Brazil, Amazonas, BR-AM
  %c Brazil, Bahia, BR-BA
  %c Brazil, Ceara, BR-CE
  %c Brazil, Distrito Federal, BR-DF
  %c Brazil, Espirto Santo, BR-ES
  %c Brazil, Fernando de Noronha, BR-FN
  %c Brazil, Goias, BR-GO
  %c Brazil, Maranhao, BR-MA
  %c Brazil, Mato Grosso, BR-MT
  %c Brazil, Mato Grosso do Sul, BR-MS
  %c Brazil, Minas Gerais, BR-MG
  %c Brazil, Para (eastern), BR-PA1
  %c Brazil, Para (western), BR-PA2
  %c Brazil, Paraiba, BR-PB
  %c Brazil, Parana, BR-PR
  %c Brazil, Pernambuco, BR-PE
  %c Brazil, Piaui, BR-PI
  %c Brazil, Rio de Janeiro, BR-RJ
  %c Brazil, Rio Grande do Norte, BR-RN
  %c Brazil, Rio Grande do Sul, BR-RS
  %c Brazil, Rondonia, BR-RO
  %c Brazil, Roraima, BR-RR
  %c Brazil, Santa Catarina, BR-SC
  %c Brazil, Sao Paulo, BR-SP
  %c Brazil, Sergipe, BR-SE
  %c Brazil, Tocantins, BR-TO
  %c Brunei Darussalam, BN
  %c Bulgaria, BG
  %c Burkina Faso, BF
  %c Burundi, BI
  %c Cambodia, KH
  %c Cameroon, CM
  %c Canada, Alberta, CA-AB
  %c Canada, British Columbia, CA-BC
  %c Canada, British Columbia (exception 1), CA-BC1
  %c Canada, British Columbia (exception 2), CA-BC2
  %c Canada, Labrador, CA2
  %c Canada, Labrador (exception), CA2A
  %c Canada, Manitoba, CA-MB
  %c Canada, New Brunswick, CA-NB
  %c Canada, Newfoundland, CA-NF
  %c Canada, Northwest Territories, CA-NT
  %c Canada, Nova Scotia, CA-NS
  %c Canada, Nunavut - Southampton Island, CA-NT2A
  %c Canada, Nunavut (Central), CA-NT2B
  %c Canada, Nunavut (Eastern), CA-NT2
  %c Canada, Nunavut (Mountain), CA-NT2C
  %c Canada, Ontario, CA-ON
  %c Canada, Ontario (western), CA-ON1
  %c Canada, Prince Edward Island, CA-PE
  %c Canada, Quebec, CA-QC
  %c Canada, Saskatchewan, CA-SK
  %c Canada, Saskatchewan (exceptions - east), CA-SK2
  %c Canada, Saskatchewan (exceptions - west), CA-SK1
  %c Canada, Yukon, CA-YT
  %c Cape Verde, CV
  %c Cayman Islands, KY
  %c Central African Republic, CF
  %c Chad, TD
  %c Chile, CL
  %c Chile - Easter Island, CL2
  %c China, CN
  %c Christmas Island (Indian Ocean), CX
  %c Cocos (Keeling) Islands, CC
  %c Colombia, CO
  %c Comoros, KM
  %c Congo, CG
  %c Congo, Democratic Republic of, Kasai Occidental, Kasai Oriental, Haut-Zaire, Shaba, CD2
  %c Congo, Democratic Republic of, Kinshasa, Bandungu, Bas-Zaire, Equateur, CD
  %c Cook Islands, CK
  %c Costa Rica, CR
  %c Cote D'Ivoire, CI
  %c Croatia, HR
  %c Cuba, CU
  %c Cyprus, CY
  %c Czech Republic, CZ
  %c Denmark, DK
  %c Djibouti, DJ
  %c Dominica, DM
  %c Dominican Republic, DO
  %c East Timor, TP
  %c Ecuador, EC
  %c Ecuador - Galapagos Islands, EC2
  %c Egypt, EG
  %c El Salvador, SV
  %c Equatorial Guinea, GQ
  %c Eritrea, ER
  %c Estonia, EE
  %c Ethiopia, ET
  %c Falkland Islands (Malvinas), FK
  %c Faroe Islands, FO
  %c Fiji, FJ
  %c Finland, FI
  %c France, FR
  %c French Guiana, GF
  %c French Polynesia, Gambier Islands, PF3
  %c French Polynesia, Marquesas Islands, PF1
  %c French Polynesia, Society Archipelago (including Tahiti), PF
  %c French Polynesia, Tuamotu Archipelago, PF2B
  %c French Polynesia, Tubuai Islands, PF2A
  %c Gabon, GA
  %c Gambia, GM
  %c Georgia, GE
  %c Germany, DE
  %c Ghana, GH
  %c Gibraltar, GI
  %c Greece, GR
  %c Greenland, Greenland, GL
  %c Greenland, Ittoqqortoormiit, Nerlerit Inaat, GL3
  %c Greenland, Pituffik, GL2
  %c Grenada, GD
  %c Guadeloupe, GP
  %c Guam, GU
  %c Guatemala, GT
  %c Guinea, GN
  %c Guinea-Bissau, GW
  %c Guyana, GY
  %c Haiti, HT
  %c Honduras, HN
  %c Hong Kong, HK
  %c Hungary, HU
  %c Iceland, IS
  %c India, IN
  %c Indonesia, (Central), ID2
  %c Indonesia, (Eastern), ID3
  %c Indonesia, (Western), ID
  %c Iran, Islamic Republic of, IR
  %c Iraq, IQ
  %c Ireland, IE
  %c Israel, IL
  %c Italy, IT
  %c Jamaica, JM
  %c Japan, JP
  %c Johnston Atoll (U.S.), UM1
  %c Jordan, JO
  %c Kazakhstan, Central, KZ2
  %c Kazakhstan, Eastern, KZ
  %c Kazakhstan, Western, KZ1
  %c Kenya, KE
  %c Kiribati, Gilbert Islands, KI
  %c Kiribati, Line Islands, KI2
  %c Kiribati, Phoenix Islands, KI3
  %c Korea, Democratic People's Republic of, KP
  %c Korea, Republic of, KR
  %c Kuwait, KW
  %c Kyrgyzstan, KG
  %c Lao People's Democratic Republic, LA
  %c Latvia, LV
  %c Lebanon, LB
  %c Lesotho, LS
  %c Liberia, LR
  %c Libyan Arab Jamahiriya, LY
  %c Liechtenstein, LI
  %c Lithuania, LT
  %c Luxembourg, LU
  %c Macau, MO
  %c Macedonia, The Former Yugoslav Republic Of, MK
  %c Madagascar, MG
  %c Malawi, MW
  %c Malaysia, MY
  %c Maldives, MV
  %c Mali, ML
  %c Malta, MT
  %c Marshall Islands, MH
  %c Martinique, MQ
  %c Mauritania, MR
  %c Mauritius, MU
  %c Mayotte, YT
  %c Mexico, Baja California Norte, MX3
  %c Mexico, Baja California Sur, MX2
  %c Mexico, Chihuahua, MX2-3
  %c Mexico, Nayarit, MX2-1
  %c Mexico, Sinaloa, MX2-2
  %c Mexico, Sonora, MX2A
  %c Mexico, South, Central, and Eastern, MX
  %c Micronesia, Federated States Of, Kosrae, Pohnpei, FM
  %c Micronesia, Federated States Of, Yap, Chuuk, FM1
  %c Midway Islands (U.S.), UM2
  %c Moldova, Republic of, MD
  %c Monaco, MC
  %c Mongolia, MN
  %c Montserrat, MS
  %c Morocco, MA
  %c Mozambique, MZ
  %c Myanmar, MM
  %c Namibia, NA
  %c Nauru, NR
  %c Nepal, NP
  %c Netherlands, NL
  %c Netherlands Antilles, AN
  %c New Caledonia, NC
  %c New Zealand, NZ
  %c New Zealand - Chatham Islands, NZ2
  %c Nicaragua, NI
  %c Niger, NE
  %c Nigeria, NG
  %c Niue, NU
  %c Norfolk Island, NF
  %c Northern Mariana Islands, MP
  %c Norway, NO
  %c Oman, OM
  %c Pakistan, PK
  %c Palau, PW
  %c Palestinian Territory, Occupied, PS
  %c Panama, PA
  %c Papua New Guinea, PG
  %c Paraguay, PY
  %c Peru, PE
  %c Philippines, PH
  %c Poland, PL
  %c Portugal, Azores, PT2
  %c Portugal, Mainland, Madeira, PT
  %c Puerto Rico, PR
  %c Qatar, QA
  %c Reunion, RE
  %c Romania, RO
  %c Russian Federation, (Zone 01), RU1
  %c Russian Federation, (Zone 02), RU
  %c Russian Federation, (Zone 03), RU3
  %c Russian Federation, (Zone 04), RU4
  %c Russian Federation, (Zone 05), RU5
  %c Russian Federation, (Zone 06), RU6
  %c Russian Federation, (Zone 07), RU7
  %c Russian Federation, (Zone 08), RU8
  %c Russian Federation, (Zone 09), RU9
  %c Russian Federation, (Zone 10), RU10
  %c Russian Federation, (Zone 11), RU11
  %c Rwanda, RW
  %c Saint Helena, SH
  %c Saint Kitts and Nevis, KN
  %c Saint Lucia, LC
  %c Saint Pierre and Miquelon, PM
  %c Saint Vincent and The Grenadines, VC
  %c Samoa, WS
  %c San Marino, SM
  %c Sao Tome and Principe, ST
  %c Saudi Arabia, SA
  %c Senegal, SN
  %c Seychelles, SC
  %c Sierra Leone, SL
  %c Singapore, SG
  %c Slovakia, SK
  %c Slovenia, SI
  %c Solomon Islands, SB
  %c Somalia, SO
  %c South Africa, ZA
  %c Spain, Canary Islands, ES2
  %c Spain, Mainland, Baleares, Melilla, Ceuta, ES
  %c Sri Lanka, LK
  %c Sudan, SD
  %c Suriname, SR
  %c Svalbard and Jan Mayen, SJ
  %c Swaziland, SZ
  %c Sweden, SE
  %c Switzerland, CH
  %c Syrian Arab Republic, SY
  %c Taiwan, TW
  %c Tajikistan, TJ
  %c Tanzania, United Republic of, TZ
  %c Thailand, TH
  %c Togo, TG
  %c Tonga, TO
  %c Trinidad and Tobago, TT
  %c Tunisia, TN
  %c Turkey, TR
  %c Turkmenistan, TM
  %c Turks and Caicos Islands, TC
  %c Tuvalu, TV
  %c Uganda, UG
  %c Ukraine, UA
  %c United Arab Emirates, AE
  %c United Kingdom, GB
  %c United States, Alabama, US-AL
  %c United States, Alaska, US-AK
  %c United States, Alaska (Aleutian Islands), US-AK1
  %c United States, Arizona, US-AZ
  %c United States, Arizona (Navajo Reservation), US-AZ1
  %c United States, Arkansas, US-AR
  %c United States, California, US-CA
  %c United States, Colorado, US-CO
  %c United States, Connecticut, US-CT
  %c United States, Delaware, US-DE
  %c United States, District of Columbia, US-DC
  %c United States, Florida, US-FL
  %c United States, Florida (far west), US-FL1
  %c United States, Georgia, US-GA
  %c United States, Hawaii, US-HI
  %c United States, Idaho (northern), US-ID1
  %c United States, Idaho (southern), US-ID
  %c United States, Illinois, US-IL
  %c United States, Indiana, US-IN
  %c United States, Indiana (exceptions), US-IN2
  %c United States, Indiana (southwest and northwest corners), US-IN1
  %c United States, Iowa, US-IA
  %c United States, Kansas, US-KS
  %c United States, Kansas (exception), US-KS1
  %c United States, Kentucky (eastern), US-KY
  %c United States, Kentucky (western), US-KY1
  %c United States, Louisiana, US-LA
  %c United States, Maine, US-ME
  %c United States, Maryland, US-MD
  %c United States, Massachusetts, US-MA
  %c United States, Michigan, US-MI
  %c United States, Michigan (exception), US-MI1
  %c United States, Minnesota, US-MN
  %c United States, Mississippi, US-MS
  %c United States, Missouri, US-MO
  %c United States, Montana, US-MT
  %c United States, Nebraska, US-NE
  %c United States, Nebraska (western), US-NE1
  %c United States, Nevada, US-NV
  %c United States, New Hampshire, US-NH
  %c United States, New Jersey, US-NJ
  %c United States, New Mexico, US-NM
  %c United States, New York, US-NY
  %c United States, North Carolina, US-NC
  %c United States, North Dakota, US-ND
  %c United States, North Dakota (western), US-ND1
  %c United States, Ohio, US-OH
  %c United States, Oklahoma, US-OK
  %c United States, Oregon, US-OR
  %c United States, Oregon (exception), US-OR1
  %c United States, Pennsylvania, US-PA
  %c United States, Rhode Island, US-RI
  %c United States, South Carolina, US-SC
  %c United States, South Dakota (eastern), US-SD
  %c United States, South Dakota (western), US-SD1
  %c United States, Tennessee (eastern), US-TN1
  %c United States, Tennessee (western), US-TN
  %c United States, Texas, US-TX
  %c United States, Texas (far west), US-TX1
  %c United States, Utah, US-UT
  %c United States, Vermont, US-VT
  %c United States, Virginia, US-VA
  %c United States, Washington, US-WA
  %c United States, West Virginia, US-WV
  %c United States, Wisconsin, US-WI
  %c United States, Wyoming, US-WY
  %c Uruguay, UY
  %c Uzbekistan, UZ
  %c Vanuatu, VU
  %c Venezuela, VE
  %c Viet Nam, VN
  %c Virgin Islands (British), VG
  %c Virgin Islands (U.S.), VI
  %c Wake Island (U.S.), UM3
  %c Wallis and Futuna, WF
  %c Yemen, YE
  %c Yugoslavia, YU
  %c Zambia, ZM
  %c Zimbabwe, ZW
  did -z $dname 2
}
; EOF
